%define cvs 0

%define	quagga_user	quagga
%define	quagga_gid	quagga
%define	vty_gid		quaggavty

Name: quagga

%define baseversion 0.99.7
Release: alt1

%if %cvs
%define cvsdate 20060505
Version: %baseversion.%cvsdate
%define quaggadir %name-%baseversion
%else
Version: %baseversion
%define quaggadir %name-%version
%endif

Packager: Sergey Y. Afonin <asy@altlinux.ru>

Summary: Quagga routing suite (a fork of GNU Zebra)

License: GPL
Group: System/Servers
Url: http://www.quagga.net/

%if %cvs
Source0:	%name-%baseversion-%cvsdate.tar.gz
%else
Source0:	%name-%version.tar.gz
%endif
Source1:	%name.logrotate
Source2:	%name.pam
Source3:	%name.sysconfig

Source10:	%name-zebra.init
Source11:	%name-ripd.init
Source12:	%name-ripngd.init
Source13:	%name-ospfd.init
Source14:	%name-ospf6d.init
Source15:	%name-bgpd.init
Source16:	%name-isisd.init

Source19:	%name-watchquagga.init

Source20:	%name-zebra.conf
Source21:	%name-ripd.conf
Source22:	%name-ripngd.conf
Source23:	%name-ospfd.conf
Source24:	%name-ospf6d.conf
Source25:	%name-bgpd.conf
Source26:	%name-isisd.conf

Patch1:		quagga-libzebra_to_libospf.patch
Patch2:		quagga-libospf_to_libospfclient.patch

Conflicts:	zebra

Requires:	libquagga	

# Automatically added by buildreq on Sat Mar 04 2006
BuildRequires: libnet-snmp-devel libpam-devel libreadline-devel libssl-devel libtinfo-devel tetex-core

%description
Quagga is a free software that manages TCP/IP based routing
protocol. It takes multi-server and multi-thread approach to resolve
the current complexity of the Internet.

Quagga supports BGP4, BGP4+, OSPFv2, OSPFv3, RIPv1, RIPv2, RIPng, 
                IS-SI and MPLS-VPN.

Quagga is intended to be used as a Route Server and a Route Reflector. It is
not a toolkit, it provides full routing power under a new architecture.
Quagga by design has a process for each protocol.

Quagga is a fork of GNU Zebra (forked after 2002-07-07).

%package -n libquagga
Summary: Quagga shared library.
Copyright: GPL
Group: System/Servers

%description -n libquagga
The runtime library of Quagga

%package devel
Summary: Header and object files for Quagga development
Group: System/Servers
Requires: libquagga	

%description devel
The quagga-devel package contains the header and object files neccessary for
developing OSPF-API and quagga applications.

%package tools
Summary: Quagga tools (zc.pl only)
Copyright: GPL
Group: System/Servers
BuildRequires: perl-Net-Telnet

%description tools
Quagga tools

%package doc
Summary: Quagga documentation
Copyright: GPL
Prereq: /sbin/install-info
Group: System/Servers

%description doc
Quagga documentation

%prep

%setup -q -n %quaggadir

#patch1 -p1
#patch2 -p1

#verify-elf: WARNING: ./usr/lib/libzebra.so.0.0.0: undefined symbol: master
#verify-elf: WARNING: ./usr/lib/libospf.so.0.0.0: undefined symbol: ospfd_privs
#verify-elf: WARNING: ./usr/lib/libospf.so.0.0.0: undefined symbol: master
#
# master in sbin/zebra
# ospfd_privs in sbin/ospfclient
#
%set_verify_elf_method unresolved=relaxed

%build

export IPFORWARD=ipforward_proc.o; export zebra_ipforward_path=proc; %configure \
        --enable-ipv6 \
        --enable-multipath=32 \
        --enable-tcp-zebra \
        --enable-nssa \
        --enable-opaque-lsa \
        --enable-ospf-te \
        --enable-vtysh \
        --enable-ospfclient=yes \
        --enable-ospfapi=yes \
        --enable-irdp=yes \
        --enable-isisd \
        --with-libpam \
        --enable-user=%quagga_user \
        --enable-group=%quagga_gid \
        --enable-vty-group=%vty_gid \
	--enable-netlink --enable-gcc-rdynamic \
	--sysconfdir=%_sysconfdir/%name \
	--localstatedir=%_localstatedir/%name

#        --disable-snmp \

%make

pushd doc
texi2html -number quagga.texi
popd

%install

install -d $RPM_BUILD_ROOT/etc/{rc.d/init.d,sysconfig,logrotate.d,pam.d} \
        $RPM_BUILD_ROOT%_logdir/%name $RPM_BUILD_ROOT%_infodir \
	$RPM_BUILD_ROOT%_localstatedir/%name 

make install DESTDIR=$RPM_BUILD_ROOT

%__rm -f $RPM_BUILD_ROOT%_libdir/lib*.a
%__rm -f $RPM_BUILD_ROOT%_sysconfdir/%name/*.sample*

%__install -m 644 %SOURCE1 $RPM_BUILD_ROOT%_sysconfdir/logrotate.d/%name
%__install -m 644 %SOURCE2 $RPM_BUILD_ROOT%_sysconfdir/pam.d/%name
%__install -m 644 %SOURCE3 $RPM_BUILD_ROOT%_sysconfdir/sysconfig/%name

%__install %SOURCE20 $RPM_BUILD_ROOT%_sysconfdir/%name/zebra.conf
%__install %SOURCE21 $RPM_BUILD_ROOT%_sysconfdir/%name/ripd.conf
%__install %SOURCE22 $RPM_BUILD_ROOT%_sysconfdir/%name/ripngd.conf
%__install %SOURCE23 $RPM_BUILD_ROOT%_sysconfdir/%name/ospfd.conf
%__install %SOURCE24 $RPM_BUILD_ROOT%_sysconfdir/%name/ospf6d.conf
%__install %SOURCE25 $RPM_BUILD_ROOT%_sysconfdir/%name/bgpd.conf
%__install %SOURCE26 $RPM_BUILD_ROOT%_sysconfdir/%name/isisd.conf

%__install -m 755 %SOURCE10 $RPM_BUILD_ROOT%_initdir/zebra
%__install -m 755 %SOURCE11 $RPM_BUILD_ROOT%_initdir/ripd
%__install -m 755 %SOURCE12 $RPM_BUILD_ROOT%_initdir/ripngd
%__install -m 755 %SOURCE13 $RPM_BUILD_ROOT%_initdir/ospfd
%__install -m 755 %SOURCE14 $RPM_BUILD_ROOT%_initdir/ospf6d
%__install -m 755 %SOURCE15 $RPM_BUILD_ROOT%_initdir/bgpd
%__install -m 755 %SOURCE16 $RPM_BUILD_ROOT%_initdir/isisd

%__cp -f tools/zc.pl $RPM_BUILD_ROOT%_bindir

%pre
/usr/sbin/groupadd -rf %quagga_gid
/usr/sbin/useradd -r -g %quagga_gid -d /dev/null -s /dev/null -n %quagga_user &>/dev/null ||:

/usr/sbin/groupadd -rf %vty_gid

%post
%post_service zebra
%post_service ripd
%post_service ospfd
%post_service ospf6d
%post_service ripngd
%post_service bgpd
%post_service isisd

%preun
%preun_service ripd
%preun_service ospfd
%preun_service ospf6d
%preun_service ripngd
%preun_service bgpd
%preun_service isisd
%preun_service zebra

%post -n libquagga -p %post_ldconfig

%postun -n libquagga -p %post_ldconfig

%post doc
/sbin/install-info %_infodir/mailutils.info.gz %_infodir/dir

%preun doc
/sbin/install-info --delete %_infodir/mailutils.info.gz %_infodir/dir

%files
%dir %_sysconfdir/%name
%attr(3775,root,%quagga_gid) %dir %_localstatedir/%name
%attr(3771,root,%quagga_gid) %dir %_logdir/%name
#attr(3775,root,%quagga_gid) %dir %_var/run/%name

%config(noreplace) %attr(0660, root, %quagga_gid) %_sysconfdir/%name/*

%config %_initdir/*
#config %_initdir/zebra
#config %_initdir/ripd
#config %_initdir/ospfd
#config %_initdir/ospf6d
#config %_initdir/ripngd
#config %_initdir/bgpd
#config %_initdir/isisd

%_sysconfdir/logrotate.d/%name
%_sysconfdir/pam.d/%name
%_sysconfdir/sysconfig/%name

%exclude %_bindir/zc.pl
%_bindir/*
%exclude %_sbindir/ospfclient
%_sbindir/*

%_mandir/man?/*
%doc AUTHORS README SERVICES COPYING NEWS

%files -n libquagga
%_libdir/lib*.so
%_libdir/lib*.so.*

%files devel
%_sbindir/ospfclient
%dir %_includedir/%name
%dir %_includedir/%name/ospfd
%dir %_includedir/%name/ospfapi
%_includedir/%name/*.h
%_includedir/%name/ospfd/*.h
%_includedir/%name/ospfapi/*.h

%files tools
%_bindir/zc.pl

%files doc
%_infodir/*
%doc tools ChangeLog INSTALL TODO
%doc doc/quagga.html
%doc */*.sample*
%doc doc/mpls
%doc bgpd/BGP4-MIB.txt ospfd/OSPF-MIB.txt ospfd/OSPF-TRAP-MIB.txt
%doc ripd/RIPv2-MIB.txt zebra/GNOME-PRODUCT-ZEBRA-MIB zebra/GNOME-SMI
%doc doc/draft-zebra-00.* doc/BGP-TypeCode

%changelog
* Wed May 16 2007 Sergey Y. Afonin <asy@altlinux.ru> 0.99.7-alt1
- New version (CVE-2007-1995, the bgpd daemon is vulnerable to a Denial-of-Service)

* Thu Apr 05 2007 Sergey Y. Afonin <asy@altlinux.ru> 0.99.6-alt3
- moved "-s 1024000" to sysconfig/quagga

* Sat Mar 24 2007 Sergey Y. Afonin <asy@altlinux.ru> 0.99.6-alt2
- added "-s 1024000" to zebra init
  (http://lists.quagga.net/pipermail/quagga-users/2006-March/006686.html
   ZEBRA: netlink-listen recvmsg overrun: No buffer space available)

* Sat Dec 16 2006 Sergey Y. Afonin <asy@altlinux.ru> 0.99.6-alt1
- New version

* Tue Oct 03 2006 Sergey Y. Afonin <asy@altlinux.ru> 0.99.5-alt1
- New version
- change: remove --disable-snmp (#9217)

* Mon May 08 2006 Sergey Y. Afonin <asy@altlinux.ru> 0.99.3.20060505-alt1
- New cvs (ripd secutity fix and some other changes)
- fix: add isisd init script to binary package
- change: remove (noreplace) for init scripts
- change: disable quagga-libzebra_to_libospf.patch and quagga-libospf_to_libospfclient.patch
  (/usr/bin/ld: cannot find -lzebra in hasher build)

* Mon Mar 20 2006 Sergey Y. Afonin <asy@altlinux.ru> 0.99.3-alt5
- add: quagga-libzebra_to_libospf.patch and quagga-libospf_to_libospfclient.patch

* Thu Mar 09 2006 Sergey Y. Afonin <asy@altlinux.ru> 0.99.3-alt4
- change: --disable-snmp (#9217)
- change: add %%set_verify_elf_method unresolved=relaxed
  (libzebra.so: undefined symbol "master" in sbin/zebra)

* Thu Mar 09 2006 Sergey Y. Afonin <asy@altlinux.ru> 0.99.3-alt3
- add: export IPFORWARD=ipforward_proc.o; export zebra_ipforward_path=proc;
  for build for linux without /proc

* Sun Mar 05 2006 Sergey Y. Afonin <asy@altlinux.ru> 0.99.3-alt2
- fix: change PID file location to /var/lib/quagga in quagga.logrotate
  and init scripts

* Thu Mar 02 2006 Sergey Y. Afonin <asy@altlinux.ru> 0.99.3-alt1
- Initial build for AltLinux 
  (used some ALT specific files from zebra-0.95-alt2)
